"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.module.css
var require_src = __commonJS({
  "src/index.module.css"() {
    "use strict";
    var style = document.createElement("style");
    style.textContent = '"._main_ubzcz_1 {\\n  position: relative;\\n}\\n._main_ubzcz_1:hover ._track_ubzcz_5 {\\n  opacity: 0.75;\\n}\\n._wrapper_ubzcz_9 {\\n  position: relative;\\n  height: 100%;\\n  overflow: hidden;\\n}\\n._inner_ubzcz_15 {\\n  position: relative;\\n  height: 100%;\\n  box-sizing: border-box;\\n  overflow-y: scroll;\\n}\\n._track_ubzcz_5 {\\n  position: absolute;\\n  top: 0;\\n  right: 3px;\\n  cursor: default;\\n  -webkit-user-select: none;\\n  -moz-user-select: none;\\n  user-select: none;\\n  width: 6px;\\n  min-height: 30px;\\n  max-height: 100%;\\n  background: rgba(0, 0, 0, 0.4);\\n  border-radius: 4px;\\n  opacity: 0;\\n  transition: opacity 0.25s ease-in;\\n  z-index: 1;\\n}\\n._track_ubzcz_5:hover {\\n  width: 10px;\\n  right: 1px;\\n}\\n"';
    document.head.appendChild(style);
    return { "main": "_main_ubzcz_1", "wrapper": "_wrapper_ubzcz_9", "inner": "_inner_ubzcz_15", "track": "_track_ubzcz_5" };
  }
});

// src/index.tsx
var src_exports = {};
__export(src_exports, {
  default: () => src_default
});
module.exports = __toCommonJS(src_exports);
var import_react2 = require("react");

// src/useCustomScroller.ts
var import_react = require("react");
var OS_SCROLLBAR_WIDTH = (() => {
  const outer = document.createElement("div");
  const inner = document.createElement("div");
  outer.style.overflow = "scroll";
  outer.style.width = "100%";
  inner.style.width = "100%";
  document.body.appendChild(outer);
  outer.appendChild(inner);
  const scrollbarWidth = outer.offsetWidth - inner.offsetWidth;
  outer.removeChild(inner);
  document.body.removeChild(outer);
  return scrollbarWidth;
})();
var SCROLLBAR_WIDTH = OS_SCROLLBAR_WIDTH || 20;
function useCustomScroller(customRef, { disabled } = { disabled: false }) {
  const [scrollRatio, setScrollRatio] = (0, import_react.useState)(1);
  const [isDraggingTrack, setIsDraggingTrack] = (0, import_react.useState)(false);
  const ref = (0, import_react.useRef)(null);
  const scrollerRef = customRef || ref;
  const trackRef = (0, import_react.useRef)(null);
  const trackAnimationRef = (0, import_react.useRef)(0);
  const memoizedProps = (0, import_react.useRef)();
  (0, import_react.useLayoutEffect)(() => {
    const el = scrollerRef.current;
    if (!el) return;
    let scrollbarAnimation;
    const updateScrollbar = () => {
      cancelAnimationFrame(scrollbarAnimation);
      scrollbarAnimation = requestAnimationFrame(() => {
        var _a, _b;
        const { clientHeight, scrollHeight } = el;
        setScrollRatio(clientHeight / scrollHeight);
        memoizedProps.current = {
          clientHeight,
          scrollHeight,
          trackHeight: (_b = (_a = trackRef.current) == null ? void 0 : _a.clientHeight) != null ? _b : 0
        };
      });
    };
    const resizeObserver = new ResizeObserver(updateScrollbar);
    const observeScroller = () => {
      resizeObserver.observe(el);
      for (const node of el.children) {
        resizeObserver.observe(node);
      }
    };
    observeScroller();
    const mutationObserver = new MutationObserver(() => {
      resizeObserver.disconnect();
      observeScroller();
      updateScrollbar();
    });
    mutationObserver.observe(el, { childList: true, subtree: true });
    window.addEventListener("resize", updateScrollbar);
    updateScrollbar();
    return () => {
      cancelAnimationFrame(scrollbarAnimation);
      window.removeEventListener("resize", updateScrollbar);
      resizeObserver.disconnect();
      mutationObserver.disconnect();
    };
  }, [scrollerRef]);
  (0, import_react.useLayoutEffect)(() => {
    if (!disabled) return;
    const el = scrollerRef.current;
    if (!el) return;
    const onWheel = (e) => e.preventDefault();
    el.addEventListener("wheel", onWheel, { passive: false });
    return () => {
      el.removeEventListener("wheel", onWheel);
    };
  }, [scrollerRef, disabled]);
  const onScroll = (0, import_react.useCallback)(() => {
    if (scrollRatio === 1) return;
    const el = scrollerRef.current;
    const track = trackRef.current;
    if (!el || !track) return;
    cancelAnimationFrame(trackAnimationRef.current);
    trackAnimationRef.current = requestAnimationFrame(() => {
      if (!memoizedProps.current) return;
      const { clientHeight, scrollHeight, trackHeight } = memoizedProps.current;
      const ratio = el.scrollTop / (scrollHeight - clientHeight);
      const y = ratio * (clientHeight - trackHeight);
      track.style.transform = `translateY(${y}px)`;
    });
  }, [scrollerRef, scrollRatio]);
  const moveTrack = (0, import_react.useCallback)(
    (e) => {
      const el = scrollerRef.current;
      if (!el) return;
      let moveAnimation;
      let lastPageY = e.pageY;
      let lastScrollTop = el.scrollTop;
      setIsDraggingTrack(true);
      const drag = ({ pageY }) => {
        cancelAnimationFrame(moveAnimation);
        moveAnimation = requestAnimationFrame(() => {
          const delta = pageY - lastPageY;
          lastScrollTop += delta / scrollRatio;
          lastPageY = pageY;
          el.scrollTop = lastScrollTop;
        });
      };
      const stop = () => {
        setIsDraggingTrack(false);
        window.removeEventListener("mousemove", drag);
      };
      window.addEventListener("mousemove", drag);
      window.addEventListener("mouseup", stop, { once: true });
    },
    [scrollerRef, scrollRatio]
  );
  const wrapperProps = {
    style: {
      marginLeft: `-${SCROLLBAR_WIDTH}px`
    }
  };
  const scrollerProps = {
    ref: scrollerRef,
    onScroll: disabled ? void 0 : onScroll,
    style: {
      right: `-${SCROLLBAR_WIDTH}px`,
      padding: `0 ${SCROLLBAR_WIDTH}px 0 0`,
      width: `calc(100% + ${OS_SCROLLBAR_WIDTH}px)`
    }
  };
  const trackProps = {
    ref: trackRef,
    onMouseDown: disabled ? void 0 : moveTrack,
    style: {
      right: isDraggingTrack ? 1 : void 0,
      width: isDraggingTrack ? 10 : void 0,
      height: `${scrollRatio * 100}%`,
      opacity: isDraggingTrack ? 1 : void 0,
      display: disabled || scrollRatio === 1 ? "none" : void 0
    }
  };
  return [wrapperProps, scrollerProps, trackProps];
}

// src/index.tsx
var import_index = __toESM(require_src());
var import_jsx_runtime = require("react/jsx-runtime");
var cx = (...args) => args.filter(Boolean).join(" ");
var CustomScroller = (0, import_react2.forwardRef)(
  ({ scrollDisabled = false, className, innerClassName, children, ...props }, ref) => {
    const [wrapperProps, scrollerProps, trackProps] = useCustomScroller(
      ref !== null && "current" in ref ? ref : void 0,
      { disabled: scrollDisabled }
    );
    return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("div", { className: cx(className, import_index.default.main), ...props, children: [
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { className: import_index.default.wrapper, ...wrapperProps, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { className: cx(innerClassName, import_index.default.inner), ...scrollerProps, children }) }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { className: import_index.default.track, ...trackProps })
    ] });
  }
);
CustomScroller.displayName = "CustomScroller";
var src_default = CustomScroller;
//# sourceMappingURL=index.js.map